// ********(PERSONAL)*******************************************************
// ANIMATION EXAMPLE BY CMSCraig@aol.com
// If you would like to get the executable or anything more E-Mail me.
// Please E-Mail suggestions, or anything to me. I would like to hear about
// anything that I could be helpfull with. This has no liscence or anything,
// and is _COMPLETELY_ free source to use. Some of the concepts were borrowed
// by my idol, Steve Rimmer. Look into his book Super VGA Graphics, 
// Programming Secrets published by (c)1993 Windcrest/McGraw-Hill. 

// ********(COMPILER INFORMATION)*******************************************
// This program was compiled with no errors on Borland TC version 3.0.
// Large Memory Model, with almost all warnings turned off. (I don't do much
// with portablity and ANSI) If you encounter problems, just try to hack it
// out. What's programming without a bit of lockup? To give you a clue, I am
// programming and compiling on a IBM Thinkpad 500 (486SLC2/50Mhz). Being a 
// laptop, when it locks up you have to pull the battery pack, and the cord
// to recover (it has a software based reset/power on-off).

// ********(PROGRAM SPECIFICS)**********************************************
// This program loads 3 .FRG files (for reference to FRG you need to donate
// some of your $$$ to Steve Rimmer's cause and buy the book above), then it
// throws them into the buffers allocated at startup. Switches to graphics
// 320x200x256 and puts the first one up using memcpy. then it cycles through
// the other two and starts over until you hit a key. The program is very 
// basic at this point. It's not a full program, but a portion of my upcomming
// video game.

// ********(FUTURE ENHANCEMENTS)********************************************
// Look for more code snippets from my upcomming shareware game. I am just
// trying to promote more programmers by giving it out so let me know if you
// like em. Planned Enhancements: Movement of the frag across the screen, 
// bitmap in background where the frag will move over without messing it up.

//**************************************************************************
//**********************( PROGRAM DATA )************************************
//**************************************************************************
#include "stdio.h"
#include "dos.h"
#include "alloc.h"

#define	IMAGESIG			"IFRG"
#define	RGB_SIZE			3
#define ANIM1				"ANIM1.FRG"
#define ANIM2				"ANIM2.FRG"
#define ANIM3				"ANIM3.FRG"

// FRAGMENT STRUCTURE USED FOR THE ACTUAL FILES
struct FRGHeader {
	char sig[4];
	unsigned int width,depth,bits,bytes,planebytes;
	unsigned long palette;
	unsigned long image;
} frg[4];

// THE STRUCTURE FOR THE FOUR ANIMATIONS DATA 68 x 125
struct NPCInfo {
	char *image[126];
	int x,y;
} npc[4];

char 	*npcbkg[126];			// SCREEN BUFFER FOR LATER USE OF BACKGRND
char 	palette[768];			// PALETTE TO BE STORED HERE
FILE 	*m[3];          		// FILE HANDLES FOR THE FRGS

unsigned int 	screenwide=320,
				screendeep=200,
				screenbytes=320;

char *screentable[200];        	// THIS IS WHERE THE SCREEN ADDRESS POINTER
								// IS THAT WE WILL USE FOR THE PLACEMENT OF
								// THE FRAGMENT FILES' DATA

main()
{	int i,r;
	printf("ANIMATE THE FRG V3.0 CMSCraig@aol.com\n");
	printf("*************************************\n");
	printf("Allocating memory...\n");
	for(i=0;i<126;++i) 
		if((npcbkg[i]=malloc(68))==NULL) err("ALLOCATE ERROR 1\n");
	printf("Background Allocated\n");
	for(r=0;r<3;++r)
	{	for(i=0;i<126;++i) 
			if((npc[r].image[i]=malloc(68))==NULL) err("ALLOCATE ERROR 2\n");
	}
	printf("Buffers Allocated\n");

	printf("Opening Files:\n");
	OpenFiles();
	graphics();
	anim();
	text();
	fcloseall();
	return(0);
}

OpenFiles()
{
	int i,t;

	// LOOP THROUGH ALL OF THE FOUR IMAGES *********************************
	for(i=0;i<3;i++)
	{	
	printf("Working on M%i.FRG\n",i+1);

		// OPEN THE NEXT FILE **********************************************
		switch(i)														  //	
		{	case 0:                                                       //
				if((m[i]=fopen(ANIM1,"rb"))==NULL)   					  //
					err("ERROR OPENING M1.FRG\n");                        //
				printf("M1.FRG Opened\n");                                //
				break;                                                    //
			case 1:                                                       //
				if((m[i]=fopen(ANIM2,"rb"))==NULL)                       //
					err("ERROR OPENING M2.FRG\n");                        //
				printf("M2.FRG Opened\n");                                //
				break;                                                    //
			case 2:                                                       //
				if((m[i]=fopen(ANIM3,"rb"))==NULL)                       //
					err("ERROR OPENING M3.FRG\n");                        //
				printf("M3.FRG Opened\n");                                //
				break;                                                    //
		}                                                                 //
		//******************************************************************


		// READ THE HEADER *************************************************
		printf("Reading Header...",i+1);								  //
		if(fread((char *)&frg[i],1,sizeof(frg),m[i])!=sizeof(frg))        //
			err("FAILED READ\n");                                         //
		if(memcmp(frg[i].sig,IMAGESIG,4))                                 //
			err("NOT A FRG FILE\n");                                      //
		else printf("SUCCESS\n");                                         //
		printf("INFO -> (%u by %u) with %u bit(s) of colour\r\n",		  //
		frg[i].width,frg[i].depth,frg[i].bits);                           //
		//******************************************************************

				
		// LOAD THE PALETTE ************************************************
		printf("Loading Palette...");									  //
		if(frg[i].bits > 1 && frg[i].bits <= 8)                           //
		{	fseek(m[i],(unsigned long)frg[i].palette,SEEK_SET);           //
			if(fread(palette,RGB_SIZE,1<<frg[i].bits,m[i]) != 			  //	
				(1<<frg[i].bits)) err("FAILED PALETTE\n");                //
		}                                                                 //
		printf("LOADED\n");                                               //
		//******************************************************************

		
		// LOAD THE IMAGE INTO THE NPC STRUCTURE ***************************
		fseek(m[i],(unsigned long)frg[i].image+4,SEEK_SET);				  //
		for(t=0;t<frg[i].depth;++t)                                       //
		{	if(i >= screendeep) break;                                    //
			if(fread(npc[i].image[t],1,frg[i].bytes,m[i]) !=			  //
				frg[i].bytes) break;                                      //
		}                                                                 //
		//******************************************************************
	}
	return(0);
}

// ANIMATE THE FRAGS LOADED INTO THE IMAGE BUFFERS
anim()
{
	int r,i;
	do
	{	
		if(r>=4) r=1;
		else r++;
		if(frg[r].bits == 8) 
		{
			for(i=0;i<frg[r].depth;++i) 
			{
				if(i >= screendeep) break;
				memcpy(screentable[i],npc[r].image[i],frg[r].bytes);
			}
		}
		delay(50);
	} while(kbhit()==0);
	return(0);
}

// SWITCH MODE TO TEXT 
text()
{	union REGS r;
	r.h.ah=0;
	r.h.al=0x0003;
	int86(0x10,&r,&r);
	return(0);
}

// SWITCH MODE TO 13H
graphics()
{	union REGS r;
	int i;
	r.h.ah=0;
	r.h.al=0x0013;
	for(i=0;i<screendeep;++i)
	    screentable[i]=MK_FP(0xa000,i*screenbytes);
	int86(0x10,&r,&r);
	setvgapalette(palette);
	return(0);
}

// PUT THE PALETTE IN IT'S PROPER PLACE
setvgapalette(p)
	char *p;
{
	int i,j,n=8;

	j=1<<n;
	outp(0x3c6,0xff);
	for(i=0;i<j;++i) {
		outp(0x3c8,i);
		outp(0x3c9,(*p++) >> 2);
		outp(0x3c9,(*p++) >> 2);
		outp(0x3c9,(*p++) >> 2);
	}
	return(0);
}

// MY LITTLE ERROR HANDLER IF IT SHOULD HAPPEN TO YA :>
err( c )
	char * c;
{	printf("%s",c);
	printf("\n---PRESS ANY KEY TO EXIT---\n");
	getch();
	exit(0);
	return(0);
}
